/**
  ******************************************************************************
  * File Name          : ak4118.h
  * Description        : AK4118 defines
  ******************************************************************************
  */
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __AK4118_H
#define __AK4118_H

#include "stm32f0xx_hal.h"

#define AK4118_I2C_ADDR				0x20 // ak4118 i2c slave address, 0010000x = 0x20 (CAD1=L CAD0=L)

/* AK4118 GPIO pins */
#define AK4118_PDN_PIN 				GPIO_PIN_12					/* PD: PB12 */
#define AK4118_PDN_PORT 			GPIOB
#define AK4118_INT0_PIN 			GPIO_PIN_14					/* INT0: PB12 */
#define AK4118_INT0_PORT 			GPIOB
#define AK4118_INT1_PIN 			GPIO_PIN_13					/* INT1: PB13 */
#define AK4118_INT1_PORT 			GPIOB

/* AK4118 Registers */
#define AK4118_REG_CLK_PWR_CTL		0x00
#define AK4118_REG_FORMAT_CTL		0x01
#define AK4118_REG_IO_CTL0			0x02
#define AK4118_REG_IO_CTL1			0x03
#define AK4118_REG_INT0_MASK		0x04
#define AK4118_REG_INT1_MASK		0x05
#define AK4118_REG_RCV_STATUS0		0x06
#define AK4118_REG_RCV_STATUS1		0x07
#define AK4118_REG_RXCHAN_STATUS0	0x08
#define AK4118_REG_RXCHAN_STATUS1	0x09
#define AK4118_REG_RXCHAN_STATUS2	0x0a
#define AK4118_REG_RXCHAN_STATUS3	0x0b
#define AK4118_REG_RXCHAN_STATUS4	0x0c
#define AK4118_REG_TXCHAN_STATUS0	0x0d
#define AK4118_REG_TXCHAN_STATUS1	0x0e
#define AK4118_REG_TXCHAN_STATUS2	0x0f
#define AK4118_REG_TXCHAN_STATUS3	0x10
#define AK4118_REG_TXCHAN_STATUS4	0x11
#define AK4118_REG_BURST_PREAMB_PC0	0x12
#define AK4118_REG_BURST_PREAMB_PC1	0x13
#define AK4118_REG_BURST_PREAMB_PD0	0x14
#define AK4118_REG_BURST_PREAMB_PD1	0x15
#define AK4118_REG_QSUB_CTL			0x16
#define AK4118_REG_QSUB_TRACK		0x17
#define AK4118_REG_QSUB_INDEX		0x18
#define AK4118_REG_QSUB_MIN			0x19
#define AK4118_REG_QSUB_SEC			0x1a
#define AK4118_REG_QSUB_FRAME		0x1b
#define AK4118_REG_QSUB_ZERO		0x1c
#define AK4118_REG_QSUB_ABS_MIN		0x1d
#define AK4118_REG_QSUB_ABS_SEC		0x1e
#define AK4118_REG_QSUB_ABS_FRAME	0x1f
#define AK4118_REG_GPE				0x20
#define AK4118_REG_GPDR				0x21
#define AK4118_REG_GPSCR			0x22
#define AK4118_REG_GPLR				0x23
#define AK4118_REG_DAT_MASK_DTS		0x24
#define AK4118_REG_RX_DETECT		0x25
#define AK4118_REG_STC_DAT_DETECT	0x26
#define AK4118_REG_RXCHAN_STATUS5	0x27
#define AK4118_REG_TXCHAN_STATUS5	0x28
#define AK4118_REG_MAX				0x29

#define AK4118_REG_FORMAT_CTL_DIF0	(1 << 4)
#define AK4118_REG_FORMAT_CTL_DIF1	(1 << 5)
#define AK4118_REG_FORMAT_CTL_DIF2	(1 << 6)
#define CHECK_BIT(var,pos) ((var) & (1<<(pos)))

uint8_t ak4118_Init(void);

#endif /* __4118_H */
