/**
  ******************************************************************************
  * File Name          : akm.h
  * Description        : AKM common defines
  ******************************************************************************
  */
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __AKM_H
#define __AKM_H

#include "stm32f0xx_hal.h"

/* AKM I2C */
#define AKM_I2C 			I2C2
#define AKM_I2C_CLK			RCC_APB1Periph_I2C1
#define AKM_I2C_TIMING	 		0x2000090E

#define AKM_I2C_SCL_PIN			GPIO_PIN_10
#define AKM_I2C_SCL_GPIO_PORT		GPIOB
#define AKM_I2C_SCL_AF			GPIO_AF1_I2C2

#define AKM_I2C_SDA_PIN			GPIO_PIN_11
#define AKM_I2C_SDA_GPIO_PORT		GPIOB
#define AKM_I2C_SDA_AF			GPIO_AF1_I2C2

HAL_StatusTypeDef write_register(int devaddr, uint8_t regaddr, uint8_t value);
HAL_StatusTypeDef read_register(int devaddr, uint8_t regaddr, uint8_t *value);
void AKM_Init(void);

#endif /* __AKM_H */
