/**
  ******************************************************************************
  * File Name          : ak4118.c
  * Description        : AK4118 functions
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "stm32f0xx_hal.h"

#include "akm.h"
#include "ak4118.h"

uint8_t ak4118_Init()
{
	HAL_StatusTypeDef status = write_register(AK4118_I2C_ADDR, AK4118_REG_CLK_PWR_CTL, 0x0b);
	if (status != HAL_OK) {
		return status;
	}
	status = write_register(AK4118_I2C_ADDR, AK4118_REG_FORMAT_CTL, 0x5a);
	if (status != HAL_OK) {
		return status;
	}
	status = write_register(AK4118_I2C_ADDR, AK4118_REG_IO_CTL0, 0x0a);
	if (status != HAL_OK) {
		return status;
	}
	status = write_register(AK4118_I2C_ADDR, AK4118_REG_DAT_MASK_DTS, 0x3a);
	return status;
}
